﻿/* =========================================================================

InDesign ExtendScript

NAME: sdPHs
VERSION: 1.0.3.16

AUTHOR: Michail Silin aka Glutton
DATE  : 30.08.2005

DESCRIPTION:
	В выбранном диапазоне страниц удаляет разделы (section), применяя к текущей и предыдущей страницам "Основной шаблон".
	Создает разделы, на страницах на которых находится параграф заданного стиля, с названием
	"/начальный_разделитель/ Найденный_параграф#1 /срединный_разделитель/ ... 
	/срединный_разделитель/ Найденный_параграф#n /конечный_разделитель/".

ICQ: 216959030 

E-MAIL: glutton@mail.ru
============================================================================ */

myParagraphStyleNameSelect = "";
myParagraphStyleName = new Array();
mySelectIndexParagraphStyle = 0;
myMasterSpreadsNameSelect = "";
myMasterSpreadsName = new Array(); 
mySelectIndexmasterSpreads = 0;
myText = "";
myP=1;
myT=1;
myA=1;
myS=1;
with(app){
	if(documents.length == 0){ alert("Нет открытых документов"); exit();}
	myDoc = activeDocument;
	for (myCounter = 0; myCounter < myDoc.paragraphStyles.length; myCounter++) {
		myParagraphStyleName[myCounter] = myDoc.paragraphStyles.item(myCounter).name;
		if (myParagraphStyleName[myCounter] == myParagraphStyleNameSelect) {
			mySelectIndexParagraphStyle = myCounter;
		}
	}
	for (myCounter = 0; myCounter < myDoc.masterSpreads.length; myCounter++) {
		myMasterSpreadsName[myCounter] = myDoc.masterSpreads.item(myCounter).name;
		if (myMasterSpreadsName[myCounter] == myMasterSpreadsNameSelect) {
			mySelectIndexmasterSpreads = myCounter;
		}
	}
	var myDialog = dialogs.add({name:"sdPHs 1.0.3.16 • Скользящие колонтитулы • Glutton • InDesign.ruDTP.ru"});
	with (myDialog.dialogColumns.add()) {
		with (dialogRows.add().borderPanels.add().dialogColumns.add()) {
			with (dialogRows.add()) {
				staticTexts.add({staticLabel:"Обрабатывать параграфы стиля:"});
				var myDialogParagraphStyle = dropdowns.add({stringList:myParagraphStyleName, selectedIndex:mySelectIndexParagraphStyle});
			}
			with (dialogRows.add()) {
				staticTexts.add({staticLabel:"Cтраницы c:"});
				var myDialogStartPage = integerEditboxes.add();
				myDialogStartPage.maximumValue=myDoc.pages.length+1;
				myDialogStartPage.minimumValue=1;
				myDialogStartPage.editValue=1;
				staticTexts.add({staticLabel:" по:"});
				var myDialogEndPage = integerEditboxes.add();
				myDialogEndPage.maximumValue=myDoc.pages.length+1;
				myDialogEndPage.minimumValue=1;
				myDialogEndPage.editValue=myDoc.pages.length+1;
			}
			with (dialogRows.add()) {
				staticTexts.add({staticLabel:"Начальный шаблон:"});
				var myDialogStartMaster = dropdowns.add({stringList:myMasterSpreadsName, selectedIndex:mySelectIndexmasterSpreads});
			}
			with (dialogRows.add()) {
				staticTexts.add({staticLabel:"Основной шаблон:"});
				var myDialogMidMaster = dropdowns.add({stringList:myMasterSpreadsName, selectedIndex:mySelectIndexmasterSpreads});
			}
			with (dialogRows.add()) {
				staticTexts.add({staticLabel:"Конечный шаблон:"});
				var myDialogEndMaster = dropdowns.add({stringList:myMasterSpreadsName, selectedIndex:mySelectIndexmasterSpreads});
			}
			with (dialogRows.add()) {
				staticTexts.add({staticLabel:"Начальный разделитель:"});
				var myDialogStartMarker = textEditboxes.add("");
			}
			with (dialogRows.add()) {
				staticTexts.add({staticLabel:"Срединный разделитель:"});
				var myDialogMidMarker = textEditboxes.add("");
			}
			with (dialogRows.add()) {
				staticTexts.add({staticLabel:"Конечный разделитель:"});
				var myDialogEndMarker = textEditboxes.add("");
			}
		}
	}
	var myResult = myDialog.show();
	if(myResult){
		myParagraphStyle = myDoc.paragraphStyles[myDialogParagraphStyle.selectedIndex];
		myStartMarker = myDialogStartMarker.editContents;
		myMidMarker = myDialogMidMarker.editContents;
		myEndMarker = myDialogEndMarker.editContents;
		myStartMaster = myDoc.masterSpreads[myDialogStartMaster.selectedIndex];
		myMidMaster = myDoc.masterSpreads[myDialogMidMaster.selectedIndex];
		myEndMaster = myDoc.masterSpreads[myDialogEndMaster.selectedIndex];
		myStartPage=myDialogStartPage.editValue;
		myEndPage=myDialogEndPage.editValue;
		myDialog.destroy();
	}else{ myDialog.destroy();exit();}

	date1= new(Date);

	for (sec = myDoc.sections.length - 1; sec > 0; sec --){
		myPageNum=myDoc.sections[sec].pageStart.name;
		if((myPageNum>=myStartPage) & (myPageNum<=myEndPage)){
			myDoc.sections[sec].pageStart.appliedMaster=myMidMaster;
			if((sec>0)&((myPageNum-1)>=myStartPage)){
				myDoc.pages[myDoc.sections[sec].pageStart.name-2].appliedMaster=myMidMaster;
			}
			myDoc.sections[sec].remove();
		}
	}
	for (pag = (myStartPage-1) ; pag < (myEndPage-1); pag++) {
		myP++;
		myPage = myDoc.pages[pag];
		if (myPage.appliedMaster!=myMidMaster){myPage.appliedMaster=myMidMaster}
		for (tf = 0; tf < myPage.textFrames.length; tf++){
			myT++;
			myTF = myPage.textFrames[tf];
			if(myTF.contents!= ""){
				findPreferences = null; 
				changePreferences = null;
				findPreferences.appliedParagraphStyle = myParagraphStyle;
				var mySearch = myTF.search();
				for(sea = 0; sea<mySearch.length; sea++){
 					if(myText!= ""){
 						myA++;
						myText = myText+myMidMarker+mySearch[sea].contents;
					} else {
 						myA++;
						myText = mySearch[sea].contents;
					}
				}
			}
		}
		if(myText!= ""){
			if(pag!= 0){
				myS++;
				mySec = myDoc.sections.add();
				mySec.pageStart=myPage;
				mySec.name = "";
				mySec.continueNumbering=true;
			}
			myPage.appliedSection.marker = myStartMarker+myText+myEndMarker;
			myText = "";
		}
	}
	for (sec = myDoc.sections.length - 1; sec > 0; sec --){
		myPageNum=myDoc.sections[sec].pageStart.name;
		if((sec>0)&(myPageNum>=myStartPage) & (myPageNum<=myEndPage)){
			myDoc.pages[myDoc.sections[sec].pageStart.name-2].appliedMaster=myEndMaster;
		}
	}
	for (sec = myDoc.sections.length - 1; sec > 0; sec --){
		myPageNum=myDoc.sections[sec].pageStart.name;
		if((myPageNum>=myStartPage) & (myPageNum<=myEndPage)){
			myDoc.sections[sec].pageStart.appliedMaster=myStartMaster;
		}
	}
	var myDialog = dialogs.add({name:"sdPHs 1.0.3.16 • Скользящие колонтитулы • Glutton • InDesign.ruDTP.ru"});
	with (myDialog.dialogColumns.add()) {
		with (dialogRows.add()) {
			staticTexts.add({staticLabel:"Обработанно страниц: "+myP});
		}
		with (dialogRows.add()) {
			staticTexts.add({staticLabel:"Обработанно текстовых фреймов:"+myT});
		}
		with (dialogRows.add()) {
			staticTexts.add({staticLabel:"Найденнно заголовков:"+myA});
		}
		with (dialogRows.add()) {
			staticTexts.add({staticLabel:"Созданно разделов:"+myS});
		}
		with (dialogRows.add()) {
			date2=new(Date);
			myTime="Затрачено времени: "+(date2.getMinutes()-date1.getMinutes())+"' "+(date2.getSeconds()-date1.getSeconds())+'"';
			staticTexts.add({staticLabel:myTime});
		}
	}
	var myResult = myDialog.show();
	if(myResult){ myDialog.destroy();exit();}else{ myDialog.destroy();exit();}
}
